/*
################################################
# part of the linuxCNC-raspberry/arduino-project
# (c) by Ralf Burger 2019
# Licence GPL
# http://erste.de/ethraw/
################################################
*/
	unsigned char s_srcMac[6]; 
	unsigned char s_dstMac[6]; 
 
	unsigned char r_srcMac[6]; 
	unsigned char r_dstMac[6]; 
	unsigned char smac[ETH_ALEN];   //send to MAC
	unsigned char rmac[ETH_ALEN];   //receive for MAC

#define BUF_SIZ         1524 
        struct ifreq if_ip;     /* get ip addr */ 
 
        int ret, i;
	int rawrsockfd,rawssockfd,udpssockfd,udprsockfd; 
        int sockopt; 

static   unsigned      char recbuf[BUF_SIZ]; 
static   unsigned      char sndbuf[BUF_SIZ]; 

        ssize_t numbytes; 
        int tx_len = 0; 
static        int in_byte[5],lastin[5], lastout[5],lastgpioin[5], lastGPIOin,lastGPIOout; 
 
        struct ifreq ifopts;    /* set promiscuous mode */ 
        struct sockaddr_storage their_addr; 
 
        /* Header structures */ 
        struct ethhdr *snd_header = (struct ethhdr *)(sndbuf); 
        struct ethhdr *rec_header = (struct ethhdr *)(recbuf); 
  

        struct ifreq if_idx;
        struct ifreq if_mac;
        struct sockaddr_ll socket_address;
static  unsigned char toUDP[4];
static  unsigned int  UDP_port;

#define PINS 40
typedef struct {
	 unsigned char  dh[6];
	 unsigned char  sh[6];
	 unsigned char  tp[2];
         unsigned char outval[5];   // 5 bytes == up to 40 pins
         unsigned char inval[5];    // 5 bytes == up to 40 pins
         unsigned char key[2];      // rasPI-raw-eth-key (0x49/0x69)
	 unsigned char floatkey;	 // key of floolowing float-value
	 float	       floatval;	 // a fload-value
         unsigned int  sndrawcount;       // packet-counter
         unsigned int  recrawcount;       // packet-counter
         unsigned int  sndudpcount;       // packet-counter
         unsigned int  recudpcount;       // packet-counter
	 time_t   stamp;            // packet-timestamp
	 unsigned char spare[1500];  // spare....

         unsigned char  sdh[6];     // send header of reply-packet
         unsigned char  ssh[6];
         unsigned char  stp[2];

         unsigned char validoutval[5];   // 5 bytes == up to 40 pins
         unsigned char validinval[5];    // 5 bytes == up to 40 pins
	 unsigned char validkey[2];
	 unsigned char validfloatkey;	 // key of floolowing float-value
	 float	       validfloatval;	 // a fload-value
         unsigned int  ssndrawcount;       // packet-counter
         unsigned int  srecrawcount;       // packet-counter
         unsigned int  ssndudpcount;       // packet-counter
         unsigned int  srecudpcount;       // packet-counter

	 time_t        sstamp;          // packet-timestamp
	 unsigned char spare2[1500];  // spare....

} rasport_t;



static rasport_t portval;
static rasport_t* port_data_array =  &portval;

static rasport_t *recbufs = (rasport_t *)(recbuf);

static char dev_name[20];
static unsigned int sndrawcount;
static unsigned int recrawcount;

#define DEB_WRONG_MAC       1
#define DEB_CORRECT_MAC     2
#define DEB_LISTENING       4
#define DEB_PACKET          8
#define DEB_PAYLOAD         16
#define DEB_MOTOR           32
#define DEB_LISTLOOP        64
#define DEB_PRINT_WRONG_PACKETS 256
#define DEB_SENDING         512
#define DEB_PRINT_MATCHING  0x200
#define DEB_ALL             0xffff
#define DEBUG 0 		
static int debug;
static int testmode;

#define deb_recpkt 8    // print every packet 
#define deb_match  16   // print every matching packet
#define deb_sudp   64    // print udp snd packets
#define deb_sraw   128   // print raw snd packets
#define deb_listen 256  // every recieved bytes
#define deb_port   512  // set port commands
#define deb_quad  1024  // debug output of quadratur-signals (step_type 15)

#define testmode_sflood 64 // endless flood sending
#define testmode_nolostpk 32 // no lost-packet-check
#define testmode_porttest 16 // just set a fast tick on pin 0
#define testmode_timebase 8  // just set a timbase-tick on pin 0

#define PKTLEN 62

#define MAC_STR "%02X:%02X:%02X:%02X:%02X:%02X"

#define M(a, i) ((unsigned int *)&a[i])
#define MAC_ARG(a) M(a, 0), M(a, 1), M(a, 2), M(a, 3), M(a, 4), M(a, 5)

#define M2(a, i) (a[i])
#define MAC_ARG2(a) M2(a, 0), M2(a, 1), M2(a, 2), M2(a, 3), M2(a, 4), M2(a, 5)
void printBits(size_t const size, void const * const ptr);

static long long micros,lastmicros;

static char dname[10]={'X','Y','Z','A'};   // default names of display-rows (1st char)

int debounce=10000; //10 usec debounce of contacts if needed
static int module;
static int shkey = 12391;

